package com.fossgalaxy.games.ggj2017;

import com.fossgalaxy.games.rts.GameState;
import com.fossgalaxy.games.rts.entity.Entity;
import com.fossgalaxy.games.rts.entity.EntityType;
import com.fossgalaxy.games.rts.order.Order;
import com.fossgalaxy.games.rts.ui.GameAction;
import com.fossgalaxy.object.annotations.ObjectDef;
import org.codetome.hexameter.core.api.CubeCoordinate;

import java.awt.*;

public class UpgradeAction extends DroneAction {
	private static final Color HINT_UPGRADE_COLOUR = new Color(26,26,255,0);
	
	private EntityType from;
	private EntityType to;

    @ObjectDef("UpgradeAction")
    public UpgradeAction(EntityType first, EntityType second){
    	this.from = first;
    	this.to = second;
    }

    @Override
    public void renderHints(Graphics2D graphics2D, GameState gameState, Entity entity) {

    }

    @Override
    public Order generateOrder(CubeCoordinate cubeCoordinate, GameState gameState) {
        return new UpgradeOrder(from, to);
    }
    
    @Override
	public boolean isPossible(Entity entity, GameState s, CubeCoordinate co) {
    	return co.equals(entity.getPos()) && isPossible(entity);
	}

	@Override
    public boolean isPossible(Entity entity) {
        return from.equals(entity.getType());
    }

    @Override
    public Color getHintColour() {
        return HINT_UPGRADE_COLOUR;
    }

    @Override
    public Color getBorderColour() {
        return Color.CYAN;
    }
    
    public String toString() {
    	return "upgrade "+from;
    }
}
