package com.fossgalaxy.games.ggj2017;

import com.fossgalaxy.games.rts.GameState;
import com.fossgalaxy.games.rts.entity.Entity;
import com.fossgalaxy.games.rts.entity.EntityType;
import com.fossgalaxy.games.rts.order.Order;

public class UpgradeOrder implements Order {
	private EntityType from;
	private EntityType to;
	
	public UpgradeOrder(EntityType from, EntityType to) {
		this.from = from;
		this.to = to;
	}

	@Override
	public void doOrder(Entity host, GameState state) {
		if (!from.equals(host.getType())) {
			return;
		}
		
		int newHealth =  (int) ( host.getHealthFrac() * to.getProperty("health") );
		
		host.setType(to);
		host.setHealth(newHealth);
	}

}
